=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2012-03-26 17:01:21 +0000
+++ bzrlib/config.py	2012-04-30 08:14:51 +0000
@@ -88,6 +88,7 @@
     atomicfile,
     controldir,
     debug,
+    directory_service,
     errors,
     lazy_regex,
     library_state,
@@ -4003,6 +4004,7 @@
             remove=False):
         if directory is None:
             directory = '.'
+        directory = directory_service.directories.dereference(directory)
         directory = urlutils.normalize_url(directory)
         if remove and all:
             raise errors.BzrError(

=== modified file 'bzrlib/tests/blackbox/test_config.py'
--- bzrlib/tests/blackbox/test_config.py	2012-01-03 12:56:06 +0000
+++ bzrlib/tests/blackbox/test_config.py	2012-08-01 08:47:21 +0000
@@ -364,3 +364,15 @@
         self.assertLength(5, self.hpss_calls)
         self.assertLength(1, self.hpss_connections)
         self.assertThat(self.hpss_calls, ContainsNoVfsCalls)
+
+
+class TestConfigDirectory(tests.TestCaseWithTransport):
+
+    def test_parent_alias(self):
+        t = self.make_branch_and_tree('base')
+        t.branch.get_config_stack().set('test', 'base')
+        clone = t.branch.bzrdir.sprout('clone').open_branch()
+        clone.get_config_stack().set('test', 'clone')
+        out, err = self.run_bzr(['config', '-d', ':parent', 'test'],
+                                working_dir='clone')
+        self.assertEquals('base\n', out)

=== modified file 'doc/en/release-notes/bzr-2.5.txt'
--- doc/en/release-notes/bzr-2.5.txt	2012-06-26 23:04:30 +0000
+++ doc/en/release-notes/bzr-2.5.txt	2012-08-01 08:51:57 +0000
@@ -32,6 +32,9 @@
 .. Fixes for situations where bzr would previously crash or give incorrect
    or undesirable results.
 
+* ``bzr config`` properly handles aliases and references in the
+  ``--directory`` parameter (Vincent Ladeuil, Wouter van Heyst, #947049)
+
 * Revert use of --no-tty when gpg signing commits. (Jelmer Vernooij, #1014570)
 
 Documentation

